"""This files contains definitions of TT API endpoints. This code is automatically generated."""

ENDPOINTS = {
    "get_account": ("GET", "/account", {}),
    "update_account": ("PATCH", "/account", {}),
    "get_batches": ("GET", "/batches", {}),
    "create_batch": ("POST", "/batches", {}),
    "get_batch": ("GET", "/batches/{}", {"batch": None}),
    "delete_batch": ("DELETE", "/batches/{}", {"batch": None}),
    "update_batch": ("PATCH", "/batches/{}", {"batch": None}),
    "trace": ("POST", "/trace", {}),
    "who_am_i": ("GET", "/whoami", {}),
    "get_users": ("GET", "/users", {}),
    "create_user": ("POST", "/users", {}),
    "get_user": ("GET", "/users/{}", {"user": None}),
    "delete_user": ("DELETE", "/users/{}", {"user": None}),
    "update_user": ("PATCH", "/users/{}", {"user": None}),
    "get_user_secret": ("GET", "/users/{}/secrets", {"user": None}),
    "create_user_secret_pin": ("POST", "/users/{}/secrets", {"user": None}),
    "delete_user_secret": ("DELETE", "/users/{}/secrets", {"user": None}),
    "update_user_secret": ("PATCH", "/users/{}/secrets", {"user": None}),
    "create_user_secret": ("POST", "/secrets/{}/{}", {"account": None, "pin": None}),
    "create_user_token": ("POST", "/token", {}),
    "refresh_user_token": ("POST", "/token/refresh", {}),
    "get_user_roles": ("GET", "/roles", {}),
    "create_user_role": ("POST", "/roles", {}),
    "get_user_role": ("GET", "/roles/{}", {"role": None}),
    "delete_user_role": ("DELETE", "/roles/{}", {"role": None}),
    "update_user_role": ("PATCH", "/roles/{}", {"role": None}),
    "resolve_twin_identity": ("GET", "/resolve/{}", {"identity": None}),
    "scan_twins": ("GET", "/twins", {}),
    "create_twin": ("POST", "/twins", {}),
    "get_twin": ("GET", "/twins/{}", {"twin": None}),
    "terminate_twin": ("DELETE", "/twins/{}", {"twin": None}),
    "update_twin": ("PATCH", "/twins/{}", {"twin": None}),
    "get_twin_identities": ("GET", "/twins/{}/identities", {"twin": None}),
    "create_twin_identity": ("POST", "/twins/{}/identities", {"twin": None}),
    "get_twin_identity": (
        "GET",
        "/twins/{}/identities/{}",
        {"twin": None, "identity": None},
    ),
    "delete_twin_identity": (
        "DELETE",
        "/twins/{}/identities/{}",
        {"twin": None, "identity": None},
    ),
    "update_twin_identity": (
        "PATCH",
        "/twins/{}/identities/{}",
        {"twin": None, "identity": None},
    ),
    "get_twin_ledger_entry": (
        "GET",
        "/twins/{}/ledgers/{}",
        {"twin": None, "ledger": "personal"},
    ),
    "add_twin_ledger_entry": (
        "POST",
        "/twins/{}/ledgers/{}",
        {"twin": None, "ledger": "personal"},
    ),
    "delete_twin_ledger_entry": (
        "DELETE",
        "/twins/{}/ledgers/{}",
        {"twin": None, "ledger": "personal"},
    ),
    "update_twin_ledger_entry": (
        "PATCH",
        "/twins/{}/ledgers/{}",
        {"twin": None, "ledger": "personal"},
    ),
    "get_twin_ledger_entry_value": (
        "GET",
        "/twins/{}/ledgers/{}/value",
        {"twin": None, "ledger": "personal"},
    ),
    "update_twin_ledger_entry_value": (
        "PATCH",
        "/twins/{}/ledgers/{}/value",
        {"twin": None, "ledger": "personal"},
    ),
    "get_twin_ledger_entry_history": (
        "GET",
        "/twins/{}/ledgers/{}/history",
        {"twin": None, "ledger": "personal"},
    ),
    "get_twin_docs": ("GET", "/twins/{}/docs", {"twin": None}),
    "attach_twin_doc": ("POST", "/twins/{}/docs", {"twin": None}),
    "delete_twin_docs": ("DELETE", "/twins/{}/docs", {"twin": None}),
    "get_twin_doc": ("GET", "/twins/{}/docs/{}", {"twin": None, "doc_name": None}),
    "delete_twin_doc": (
        "DELETE",
        "/twins/{}/docs/{}",
        {"twin": None, "doc_name": None},
    ),
    "update_twin_doc": ("PATCH", "/twins/{}/docs/{}", {"twin": None, "doc_name": None}),
    "download_doc": ("GET", "/download/{}/{}", {"account": None, "handler": None}),
    "create_upload_url": ("POST", "/cache", {}),
    "invalidate_upload_url": ("DELETE", "/cache/{}", {"handler": None}),
    "get_databases": ("GET", "/account/services/databases", {}),
    "get_database": ("GET", "/account/services/databases/{}", {"database": "default"}),
    "update_database": (
        "PATCH",
        "/account/services/databases/{}",
        {"database": "default"},
    ),
    "get_database_access": (
        "GET",
        "/account/services/databases/{}/access",
        {"database": "default"},
    ),
    "update_database_user_access": (
        "PATCH",
        "/account/services/databases/{}/access/users/{}",
        {"database": "default", "user": None},
    ),
    "update_database_ip_access": (
        "PATCH",
        "/account/services/databases/{}/access/ips",
        {"database": "default"},
    ),
    "get_timeseries_table": (
        "GET",
        "/account/services/timeseries/{}",
        {"timeseries": None},
    ),
    "delete_timeseries_table": (
        "DELETE",
        "/account/services/timeseries/{}",
        {"timeseries": None},
    ),
    "update_timeseries_table": (
        "PATCH",
        "/account/services/timeseries/{}",
        {"timeseries": None},
    ),
    "get_timeseries_tables": ("GET", "/account/services/timeseries", {}),
    "create_timeseries_table": ("POST", "/account/services/timeseries", {}),
    "truncate_timeseries_table": (
        "DELETE",
        "/account/services/timeseries/{}/data",
        {"timeseries": None},
    ),
    "get_log": ("GET", "/log", {}),
    "update_notifications_account_access": (
        "PATCH",
        "/notifications/webhooks/access/accounts/{}",
        {"account": None},
    ),
    "get_notifications_access": ("GET", "/notifications/webhooks/access", {}),
    "webhook_subscribe": ("POST", "/notifications/webhooks", {}),
    "webhook_confirm_subscription": (
        "GET",
        "/notifications/webhooks/{}",
        {"account": None},
    ),
    "webhook_unsubscribe": ("DELETE", "/notifications/webhooks/{}", {"account": None}),
    "webhook_refresh_subscription": (
        "PATCH",
        "/notifications/webhooks/{}",
        {"account": None},
    ),
    "get_indexes_table": ("GET", "/account/services/indexes/{}", {"index": None}),
    "delete_indexes_table": ("DELETE", "/account/services/indexes/{}", {"index": None}),
    "update_indexes_table": ("PATCH", "/account/services/indexes/{}", {"index": None}),
    "get_indexes_tables": ("GET", "/account/services/indexes", {}),
    "create_indexes_table": ("POST", "/account/services/indexes", {}),
    "truncate_indexes_table": (
        "DELETE",
        "/account/services/indexes/{}/data",
        {"index": None},
    ),
    "get_account_usage": ("GET", "/usage", {}),
    "get_user_usage": ("GET", "/usage/{}", {"user": None}),
    "get_stickers": ("GET", "/twins/{}/stickers", {"twin": None}),
    "put_sticker": ("POST", "/twins/{}/stickers", {"twin": None}),
    "get_sticker": ("GET", "/twins/{}/stickers/{}", {"twin": None, "color": None}),
    "remove_sticker": (
        "DELETE",
        "/twins/{}/stickers/{}",
        {"twin": None, "color": None},
    ),
    "list_stickers": ("GET", "/stickers", {}),
}
